﻿#PrinterLib_Include=1
XIncludeFile "Printer_Lib.pb"

; Example adapted from TerryHough
; http://www.purebasic.fr/english/viewtopic.php?t=24510

Procedure Duplex_Test(Printer$)
  Protected OPT$,JobID,Text$
  Debug "Starting Duplex Test on "+Printer$
  OPT$="ORIENTATION="+Str(#DMORIENT_PORTRAIT)+","
  OPT$+"DEFAULTSOURCE="+Str(#DMBIN_AUTO)+","
  OPT$+"DUPLEX="+Str(#DMDUP_VERTICAL)
  If Print_OpenPrinter(Printer$,OPT$)
    JobID=Print_StartPrinting("PrinterLib Duplex Test")
    If JobID
      ; Page 1
      Debug "Starting Page 1 (JobID="+Str(JobID)+")"
      Text$ = "And where did this one print?  Should be Portrait from Upper Tray" 
      Print_Text(10,25,Text$)
      
      Print_NewPage()
      ; Page 2
      Debug "Starting Page 2 (JobID="+Str(JobID)+")"
      Text$ = "And this should be on the back of the previous page (duplex)."
      Print_Text(10,25,Text$)
      
      Print_StopPrinting()
    EndIf
  EndIf
EndProcedure

Define OPT2$,Printer$,res$

OPT2$="FLAGS="+Str(#PD_ALLPAGES | #PD_HIDEPRINTTOFILE | #PD_NOSELECTION)

If Print_PrintDlg(0,"","",OPT2$)
  Printer$=Print_GetPrinterName()
  If Print_OpenPrinter(Printer$)
    res$=Print_GetDeviceCapabilities(#DC_DUPLEX)
    Select res$
      Case "1"
        Debug Printer$+" supports duplex printing"
        Duplex_Test(Printer$)
      Case "-1"
        Debug "DeviceCapabilities() function failed" 
      Case "0"
        Debug Printer$+" does not support duplex printing" 
    EndSelect 
  Else
    Debug "No Printer Available"
  EndIf
Else
  Debug "User cancelled printing"
EndIf
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 31
; Folding = -
; Executable = test.exe